SousChef
================================================================================

A set of helpers for chef

**NOTE:** This work is on it's early days and is still under development

What sort of helpers?
--------------------------------------------------------------------------------

### For dynamic configuration

- SousChef::Config.compile_attribute
- SousChef::Config.compile_attribute_hash

### For hashes

#### souschef/lib/souschef/hash_extensions.rb

> Extends Hash class adding `.access` which doesn't differentiate between
> `string` and `symbol` key and `deep_merge` from
> [this gem](https://rubygems.org/gems/deep_merge).


About the config `compile_attribute_hash`
--------------------------------------------------------------------------------

Parses a hash replacing {prop.subprop.subsub} tokens by it's values

#### Usage:

- Reference other properties using dot-notation {site.certs.root}
- Use a :__default__ key to define default values
- Use an :__items__ key to define the items to create using the default values
- :__key__ and :__item__ keys only exist inside __default__
- Overwrite defaults by adding a key with the same name of the item

#### Example:

    default[:app] = {
      name: 'myapp',
      user: 'appuser',
      certs: {
        root: '/etc/ssl/certs/{name}',
        cert: '{certs.root}/cert.pem'
      },
      envs: {
        __default__: {
          name: '{__key__}',
          debug: true
        },
        __items__: ['dev', 'staging', 'prod'],
        prod: {
          debug: false
        }
      }
    }
